Bug 64049 - rpm -Fvh *.rpm consistently reports dependency failures.
rpm -Fvh *.rpm consistently reports dependency failures.
Status: CLOSED NOTABUG
Product: Red Hat Linux
Classification: Retired
Component: up2date (Show other bugs)
7.2
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Adrian Likins
Jay Turner
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2002-04-24 11:34 EDT by Aaron Freed
Modified: 2015-01-07 18:56 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2002-04-26 07:21:34 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Aaron Freed 2002-04-24 11:34:51 EDT
Description of Problem:
Running the UP2DATE Agent (Configured to save RPMS and SRPMS on disk as part of the update)
downloads all necessary files, announces that it needs several additional RPMS to download
(Notably such items as POPT, Perl-CPAN, Perl, etc and friends) resolve dependencies.

It downloads these items, and installs them CORRECTLY.  
However, the problem occurs if I copy all the downloaded and saved RPMS and SRPMS to another
(Identical) RedHat 7.2 (Kernel 2.4.7-10) system and then try to install the updates
with the RPM -Fvh and/or RPM -Uvh commands, the process fails with this message:


Reproducable:  100% of the time.
Steps to reproduce the problem:

1.  Copy the RPMS and SRPMs downloaded by Up2date to a 
directory on a new machine.  Then try to
install them with "rpm -Fvh *.rpm" as shown below:

[root@fortitude up2date]# rpm -Fvh *.rpm
error: failed dependencies:
        perl-CPAN is needed by perl-5.6.1-26.72.3
        perl-CGI is needed by perl-5.6.1-26.72.3
        perl-DB_File is needed by perl-5.6.1-26.72.3
        perl-NDBM_File is needed by perl-5.6.1-26.72.3
        poptmodule.so is needed by up2date-2.7.61-7.x.2
[root@fortitude up2date]#

(Two additional dependency failures involving Omni and Omni-foomatic may appear as well.  
On the machine I ran this test on, I had already installed Omni/Omni-foomatic, so
their dependency failure did not appear in the above output.)

This problem occurrs now 100 % of the time.  To get "most of the way around it" 
I find that I must manually:
rpm -ivh Omni-*
rpm -Uvh perl-*
rpm -Uvh * (Which does not complete )<----May be unnecessary
Remove all RPMs relating to the "Up2date" utility from the directory containing
the downloaded RPMs
rpm -Fvh * (Seems to work)
Do NOT install new up2date RPMs--they fail with the following error:

[root@justice up2date]# rpm -Uvh up2date-*
error: failed dependencies:
        poptmodule.so is needed by up2date-2.7.61-7.x.2

yet:
[root@justice up2date]# rpm -redhatprovides poptmodule.so
rpm-python-4.0.3-1.03

And we have just successfully installed an even newer version of rpm-python:
[root@justice up2date]# rpm -q rpm-python
rpm-python-4.0.4-7x

which has evidently provided THIS poptmodule.so:
[root@justice up2date]# slocate poptmodule.so
/usr/lib/python1.5/site-packages/poptmodule.so


Because of this problem, and the lack of a tool that actually RESOLVES 
dependencies (Other than up2date, which requires a subscription per machine), 
it is now time-consuming and almost impossible to update to the latest
RPMs.  I see that Up2Date seems to download all necessary RPMs, and it seems
to resolve dependencies successfully enough to install them.  But the 
RPM command does not seem to have this ability.  

Any thoughts or assitance would be appreciated..... (Even if it's of they 
"Hey, stupid, how come you didn't use the '--resolvedependencies_with_brilliant_
finnesse' switch variety....)

Actual Results:
Unable to use RPM to install updates completely.  Partially or incompletely 
updated machines. (Even using latest RPMs downloaded on 4/23/2002.)

Expected Results:
rpm -Fvh * should work.  Either up2date is failing to download all necessary RPMs to
resolve dependencies, RPM is unable to correctly resolve them because it is broken, or
someone is not properly updating dependency trees for the new RPMs, so when RPM tries
to resolve them, it is pointed to incorrect files and it fails.

Additional Information:
Comment 1 Adrian Likins 2002-04-24 14:52:27 EDT
-Fvh only installs updates of packages that are already installed.
Some of the packages you mentioned were added to the distro
as part of errata, so it's pretty likely you dont have them
installed currently. 

Since -Fvh wont install these new packages, and those new packages
are needed to solve deps in some of the updates, you will get 
depenecy errors.

`rpm -Uvh ` on the package set should work fine.
Comment 2 Aaron Freed 2002-04-25 09:25:19 EDT
> Here is a screen-shot of what happened when I ran "rpm -Uvh *.rpm" against 
> all the 325 RPMs I downloaded.  (Note:  This is a second run.  That is why 
> some packages report as "already being installed").
> 
> Note:  Only 97 packages install/update and the counter to the far right of 
> each package only reaches 30%, suggesting to me that the installation may not 
> be complete.
> 
>
        You have to `rpm -ivh` kernel packages (this is what
up2date does internally since they can conflict with each other)
and `rpm -Uvh` everything else. 
 
        You really need to update all the rest of the applicable
packages in one transaction set (ie, all at the same time) since
there are deps, conflicts, and obsoletes that need to be solved
at the same time. 

        `rpm -Fvh` is more or less a "useful for some circumstances"
kind of tool. It basically invokes a sheel script thats tries to
install all the latest versions of the packages you already have installed.
There are many cases where this is not adequate (this one, for example...)

> [root@fortitude rhn]# rpm -ivh *.rpm
> error: failed dependencies:
>         tux < 2.1.1-10 conflicts with kernel-2.4.9-31
>         tux < 2.1.1-10 conflicts with kernel-debug-2.4.9-31
>         rpm < 4.0.4 conflicts with python-popt-0.8.8-7.x.2
> 


> [root@fortitude rhn]# rpm -Fvh rpm*
> error: failed dependencies:
>         popt = 1.6.4 is needed by rpm-4.0.4-7x
>         popt = 1.6.4 is needed by rpm-devel-4.0.4-7x
>         popt = 1.6.4 is needed by rpm-perl-4.0.4-7x
>         popt = 1.6.4 is needed by rpm-python-4.0.4-7x
>         librpm-4.0.3.so   is needed by gnorpm-0.96-11
>         librpm-4.0.3.so   is needed by kdeadmin-2.2-8
>         librpmbuild-4.0.3.so   is needed by kdeadmin-2.2-8
>         librpmdb-4.0.3.so   is needed by gnorpm-0.96-11
>         librpmdb-4.0.3.so   is needed by kdeadmin-2.2-8
>         librpmio-4.0.3.so   is needed by gnorpm-0.96-11
>         librpmio-4.0.3.so   is needed by kdeadmin-2.2-8
>         poptmodule.so is needed by up2date-2.7.61-7.x.2

        all these packaeges depend on the old version of rpm.
You need to update them, and rpm at the same time. 
> 
> [root@fortitude rhn]# rpm -Fvh *
> error: failed dependencies:
>         poptmodule.so is needed by up2date-2.7.61-7.x.2
> 
        -Fvh * is just not going to work in this case.

> [root@fortitude rhn]# rpm -redhatprovides poptmodule.so
> rpm-python-4.0.3-1.03
> 
        That tells you what provides it in the currently
installed database. That may or may not be what provides
it in the new set of packages. In this case, it's no
longer rpm-python, but now python-popt.

> [root@fortitude rhn]# rpm -Fvh rpm-python-4.0.4-7x.i386.rpm
> error: failed dependencies:
>         rpm = 4.0.4 is needed by rpm-python-4.0.4-7x
>         popt = 1.6.4 is needed by rpm-python-4.0.4-7x
>         librpm-4.0.4.so   is needed by rpm-python-4.0.4-7x
>         librpmdb-4.0.4.so   is needed by rpm-python-4.0.4-7x
>         librpmio-4.0.4.so   is needed by rpm-python-4.0.4-7x
>         poptmodule.so is needed by up2date-2.7.61-7.x.2
> 
        See above, other packages depend on this and therefore
need to be upgraded at the same time.

> =======================================================================
> Judging from the above, it seems like pretty much a crap-shoot whether I use 
> rpm -Uvh, rpm -Fvh or rpm -ivh to install all the RPMS.  Should I even be 
> trying to install all of them?  Why would rpm -Uvh indicate perl was 
> installed, yet then I was able to install perl again to get the newer 
> version?  Similar point with Tux.
>
        Required deps move to new packages sometimes, and new packages
are released, making -Fvh not all that useful in this case. 
 
> It seems to me that "rpm -Uvh" should have installed all available rpms--not 
> just the first 97.  I guess I am just really unclear as to what is going on, 
> why things seem to install, yet I find that they aren't necessarily installed.
>
        Not sure I understand what you mean in this case. If you are specififying 300 packages to update with "-Uvh", and only 97 get installed 
without any 
errors, that sounds like a rpm bug.
 
> There has got to be an easier way....
        
        up2date?



Tried rpm -ivh kernel*  ---and got dependency errors.

rpm -Uvh kernel* seems to work, though.

Then, as you recommend above, I did "rpm -Uvh *" to install the entire package set.

And, sadly, got exactly the same result as above.

You know, Adrian, I find it rather interesting that the list of installed packages:
IS correctly listed alphabetically from A to Z.
The first time I tried it, the kernel wasn't updated. (But maybe I forgot to reboot)

....and here's the BIGGIE:
Running this command:
rpm -Uvh *.rpm on a machine THAT HAS ALREADY BEEN UPDATED WITH THE UP2DATE UTILITY
PRODUCES THIS RESULT:
[root@alliance up2date]# rpm -Uvh *.rpm
Preparing...                ########################################### [100%]
package Mesa-3.4.2-10 is already installed
package Mesa-demos-3.4.2-10 is already installed
package Mesa-devel-3.4.2-10 is already installed
package Omni-0.5.0-4 is already installed
package Omni-foomatic-0.5.0-4 is already installed
package XFree86-100dpi-fonts-4.1.0-15 is already installed
package XFree86-4.1.0-15 is already installed
package XFree86-75dpi-fonts-4.1.0-15 is already installed
package XFree86-ISO8859-15-100dpi-fonts-4.1.0-15 is already installed
package XFree86-ISO8859-15-75dpi-fonts-4.1.0-15 is already installed
package XFree86-Xnest-4.1.0-15 is already installed
package XFree86-Xvfb-4.1.0-15 is already installed
package XFree86-devel-4.1.0-15 is already installed
package XFree86-doc-4.1.0-15 is already installed
package XFree86-libs-4.1.0-15 is already installed
package XFree86-tools-4.1.0-15 is already installed
package XFree86-twm-4.1.0-15 is already installed
package XFree86-xdm-4.1.0-15is already installed
package XFree86-xf86cfg-4.1.0-15 is already installed
package XFree86-xfs-4.1.0-15 is already installed
package Xconfigurator-4.9.39-2 is already installed
package apache-1.3.22-2 is already installed
package apache-devel-1.3.22-2 is already installed
package apache-manual-1.3.22-2 is already installed
package arpwatch-2.1a11-10.7x is already installed
package arts-2.2.2-2 is already installed
package at-3.1.8-23 is already installed
package balsa-1.2.3-1 is already installed
package binutils-2.11.90.0.8-12 is already installed
package cvs-1.11.1p1-7 is already installed
package cyrus-sasl-1.5.24-23 is already installed
package cyrus-sasl-devel-1.5.24-23 is already installed
package cyrus-sasl-gssapi-1.5.24-23 is already installed
package cyrus-sasl-md5-1.5.24-23 is already installed
package cyrus-sasl-plain-1.5.24-23 is already installed
package diskcheck-1.1-1 is already installed
package dump-0.4b25-1.72.0 is already installed
package e2fsprogs-1.26-1.72 is already installed
package e2fsprogs-devel-1.26-1.72 is already installed
package eel-1.0.2-2 is already installed
package eel-devel-1.0.2-2 is already installed
package enscript-1.6.1-16.2 is already installed
package ethereal-0.8.18-10.7.2.1 is already installed
package ethereal-gnome-0.8.18-10.7.2.1 is already installed
package foomatic-1.1-0.20011218.3 is already installed
package gcc3-3.0.4-1 is already installed
package gcc3-c++-3.0.4-1 is already installed
package gcc3-g77-3.0.4-1 is already installed
package gcc3-java-3.0.4-1 is already installed
package gcc3-objc-3.0.4-1 is already installed
package gdb-5.1-1 is already installed
package ghostscript-6.51-16 is already installed
package glibc-2.2.4-24 is already installed
package glibc-common-2.2.4-24 is already installed
package glibc-devel-2.2.4-24 is already installed
package glibc-profile-2.2.4-24 is already installed
package gnorpm-0.96-12.7x is already installed
package groff-1.17.2-7.0.2 is already installed
package groff-gxditview-1.17.2-7.0.2 is already installed
package groff-perl-1.17.2-7.0.2 is already installed
package htdig-3.2.0-1.b4.0.72 is already installed
package htdig-web-3.2.0-1.b4.0.72 is already installed
package imlib-1.9.13-2.7.x is already installed
package imlib-cfgeditor-1.9.13-2.7.x is already installed
package imlib-devel-1.9.13-2.7.x is already installed
package initscripts-6.43-1 is already installed
package iptables-1.2.4-2 is already installed
package iptables-ipv6-1.2.4-2 is already installed
package jadetex-3.11-4 is already installed
package kde-i18n-Bulgarian-2.2.2-2 is already installed
package kde-i18n-Hebrew-2.2.2-2 is already installed
package kde-i18n-Lithuanian-2.2.2-2 is already installed
package kde-i18n-Polish-2.2.2-2 is already installed
package kdeaddons-kate-2.2.2-1 is already installed
package kdeaddons-kicker-2.2.2-1 is already installed
package kdeaddons-knewsticker-2.2.2-1 is already installed
package kdeaddons-konqueror-2.2.2-1 is already installed
package kdeaddons-noatun-2.2.2-1 is already installed
package kdeadmin-2.2.2-3 is already installed
package kdeartwork-2.2.2-1 is already installed
package kdeartwork-locolor-2.2.2-1 is already installed
package kdebase-2.2.2-1 is already installed
package kdebase-devel-2.2.2-1 is already installed
package kdebindings-2.2.2-1 is already installed
package kdebindings-devel-2.2.2-1 is already installed
package kdebindings-kmozilla-2.2.2-1 is already installed
package kdebindings-perl-2.2.2-1 is already installed
package kdebindings-python-2.2.2-1 is already installed
package kdegames-2.2.2-1 is already installed
package kdegraphics-2.2.2-1 is already installed
package kdegraphics-devel-2.2.2-1 is already installed
package kdelibs-2.2.2-2 is already installed
package kdelibs-devel-2.2.2-2 is already installed
package kdelibs-sound-2.2.2-2 is already installed
package kdelibs-sound-devel-2.2.2-2 is already installed
package kdemultimedia-2.2.2-2 is already installed
package kdemultimedia-devel-2.2.2-2 is already installed
package kdenetwork-2.2.2-1 is already installed
package kdenetwork-ppp-2.2.2-1 is already installed
package kdepim-2.2.2-3 is already installed
package kdepim-cellphone-2.2.2-3 is already installed
package kdepim-devel-2.2.2-3 is already installed
package kdepim-pilot-2.2.2-3 is already installed
package kdesdk-2.2.2-1 is already installed
package kdesdk-devel-2.2.2-1 is already installed
package kdetoys-2.2.2-1 is already installed
package kdeutils-2.2.2-1 is already installed
package kdevelop-2.0.2-2 is already installed
package kdoc-2.2.2-1 is already installed
package kernel-doc-2.4.9-31 is already installed
package kernel-headers-2.4.9-31 is already installed
package kernel-source-2.4.9-31 is already installed
package koffice-1.1.1-2 is already installed
package koffice-devel-1.1.1-2 is already installed
package libgcc-3.0.4-1 is already installed
package libgcj-2.96-28 is already installed
package libgcj-devel-2.96-28 is already installed
package libgcj3-3.0.4-1 is already installed
package libgcj3-devel-3.0.4-1 is already installed
package libpcap-0.6.2-10.7x is already installed
package libstdc++3-3.0.4-1 is already installed
package libstdc++3-devel-3.0.4-1 is already installed
package libxml2-2.4.10-0.7x.2 is already installed
package libxml2-devel-2.4.10-0.7x.2 is already installed
package libxslt-1.0.7-2 is already installed
package libxslt-devel-1.0.7-2 is already installed
package logwatch-2.6-1 is already installed
package mailman-2.0.8-1 is already installed
package mod_auth_pgsql-0.9.9-2 is already installed
package mod_perl-1.26-2 is already installed
package mod_ssl-2.8.5-4 is already installed
package modutils-2.4.13-0.7.1 is already installed
package mutt-1.2.5.1-1 is already installed
package ncurses4-5.0-5 is already installed
package nfs-utils-0.3.1-13.7.2.1 is already installed
package nscd-2.2.4-24 is already installed
package openldap-2.0.21-1 is already installed
package openldap-clients-2.0.21-1 is already installed
package openldap-devel-2.0.21-1 is already installed
package openldap-servers-2.0.21-1 is already installed
package openssh-3.1p1-2 is already installed
package openssh-askpass-3.1p1-2 is already installed
package openssh-askpass-gnome-3.1p1-2 is already installed
package openssh-clients-3.1p1-2 is already installed
package openssh-server-3.1p1-2 is already installed
package pam-0.75-19 is already installed
package pam-devel-0.75-19 is already installed
package perl-5.6.1-26.72.3 is already installed
package perl-CGI-2.752-26.72.3 is already installed
package perl-CPAN-1.59_54-26.72.3 is already installed
package perl-DB_File-1.75-26.72.3 is already installed
package perl-NDBM_File-1.75-26.72.3 is already installed
package php-4.0.6-15 is already installed
package php-devel-4.0.6-15 is already installed
package php-imap-4.0.6-15 is already installed
package php-ldap-4.0.6-15 is already installed
package php-manual-4.0.6-15 is already installed
package php-mysql-4.0.6-15 is already installed
package php-odbc-4.0.6-15 is already installed
package php-pgsql-4.0.6-15 is already installed
package pine-4.44-1.72.0 is already installed
package popt-1.6.4-7x is already installed
package printconf-0.3.61-3 is already installed
package printconf-gui-0.3.61-3 is already installed
package python-popt-0.8.8-7.x.2 is already installed
package python-xmlrpc-1.5.1-7.x.3 is already installed
package raidtools-0.90-24 is already installed
package redhat-config-network-0.9.10-2 is already installed
package rhn_register-2.7.9-7.x.2 is already installed
package rhn_register-gnome-2.7.9-7.x.2 is already installed
package rmt-0.4b25-1.72.0 is already installed
package rpm-4.0.4-7x is already installed
package rpm-build-4.0.4-7x is already installed
package rpm-devel-4.0.4-7x is already installed
package rpm-perl-4.0.4-7x is already installed
package rpm-python-4.0.4-7x is already installed
package rpm2html-1.7-3.7x is already installed
package rpmfind-1.7-4.7x is already installed
package rsync-2.4.6-13 is already installed
package sane-backends-1.0.5-4.1 is already installed
package sane-backends-devel-1.0.5-4.1 is already installed
package semi-xemacs-1.14.3-8 is already installed
package squid-2.4.STABLE3-1.7.2 is already installed
package stunnel-3.22-1 is already installed
package sudo-1.6.4-0.7x.2 is already installed
package tcpdump-3.6.2-10.7x is already installed
package tetex-1.0.7-38.2 is already installed
package tetex-afm-1.0.7-38.2 is already installed
package tetex-doc-1.0.7-38.2 is already installed
package tetex-dvilj-1.0.7-38.2 is already installed
package tetex-dvips-1.0.7-38.2 is already installed
package tetex-fonts-1.0.7-38.2 is already installed
package tetex-latex-1.0.7-38.2 is already installed
package tetex-xdvi-1.0.7-38.2 is already installed
package tmpwatch-2.8.1-1 is already installed
package ttfonts-ja-1.0-7 is already installed
package tux-2.2.0-1 is already installed
package ucd-snmp-4.2.3-1.7.2.3 is already installed
package ucd-snmp-devel-4.2.3-1.7.2.3 is already installed
package ucd-snmp-utils-4.2.3-1.7.2.3 is already installed
package up2date-2.7.61-7.x.2 is already installed
package up2date-gnome-2.7.61-7.x.2 is already installed
package usermode-1.46-1 is already installed
package util-linux-2.11f-17 is already installed
package uucp-1.06.1-33.7.2 is already installed
package vim-X11-6.0-7.13 is already installed
package vim-common-6.0-7.13 is already installed
package vim-enhanced-6.0-7.13 is already installed
package vim-minimal-6.0-7.13 is already installed
package vnc-3.3.3r2-18.4 is already installed
package vnc-doc-3.3.3r2-18.4 is already installed
package vnc-server-3.3.3r2-18.4 is already installed
package webalizer-2.01_09-0.72 is already installed
package wu-ftpd-2.6.1-20 is already installed
package xchat-1.8.7-1.72.0 is already installed
package xemacs-21.1.14-23.7.2 is already installed
package xemacs-el-21.1.14-23.7.2 is already installed
package xemacs-info-21.1.14-23.7.2 is already installed
package xsane-0.82-3.1 is already installed
package xsane-gimp-0.82-3.1 is already installed
package zlib-1.1.3-25.7 is already installed
package zlib-devel-1.1.3-25.7 is already installed
   1:Mesa                   ########################################### [  0%]
   2:Omni                   ########################################### [  0%]
   3:XFree86                ########################################### [  0%]
   4:Xconfigurator          ########################################### [  1%]
   5:apache                 ########################################### [  1%]
   6:at                     ########################################### [  1%]
   7:balsa                  ########################################### [  2%]
   8:binutils               ########################################### [  2%]
   9:cvs                    ########################################### [  2%]
  10:cyrus-sasl             ########################################### [  3%]
  11:diskcheck              ########################################### [  3%]
  12:dump                   ########################################### [  3%]
  13:e2fsprogs              ########################################### [  4%]
  14:eel                    ########################################### [  4%]
  15:enscript               ########################################### [  4%]
  16:ethereal               ########################################### [  4%]
  17:foomatic               ########################################### [  5%]
  18:gcc3                   ########################################### [  5%]
  19:gdb                    ########################################### [  5%]
  20:ghostscript            ########################################### [  6%]
  21:glibc                  ########################################### [  6%]
  22:gnorpm                 ########################################### [  6%]
  23:groff                  ########################################### [  7%]
  24:htdig                  ########################################### [  7%]
  25:imlib                  ########################################### [  7%]
  26:initscripts            ########################################### [  8%]
  27:iptables               ########################################### [  8%]
  28:jadetex                ########################################### [  8%]
  29:kde-i18n               ########################################### [  9%]
  30:kdeaddons              ########################################### [  9%]
  31:kdeadmin               ########################################### [  9%]
  32:kdeartwork             ########################################### [  9%]
  33:kdebase                ########################################### [ 10%]
  34:kdebindings            ########################################### [ 10%]
  35:kdegames               ########################################### [ 10%]
  36:kdegraphics            ########################################### [ 11%]
  37:kdelibs                ########################################### [ 11%]
  38:kdemultimedia          ########################################### [ 11%]
  39:kdenetwork             ########################################### [ 12%]
  40:kdepim                 ########################################### [ 12%]
  41:kdesdk                 ########################################### [ 12%]
  42:kdetoys                ########################################### [ 13%]
  43:kdeutils               ########################################### [ 13%]
  44:kdevelop               ########################################### [ 13%]
  45:kdoc                   ########################################### [ 13%]
  46:kernel                 ########################################### [ 14%]
  47:koffice                ########################################### [ 14%]
  48:libgcj                 ########################################### [ 14%]
  49:libxml2                ########################################### [ 15%]
  50:libxslt                ########################################### [ 15%]
  51:logwatch               ########################################### [ 15%]
  52:mailman                ########################################### [ 16%]
  53:mod_auth_pgsql         ########################################### [ 16%]
  54:mod_perl               ########################################### [ 16%]
  55:mod_ssl                ########################################### [ 17%]
  56:modutils               ########################################### [ 17%]
  57:mutt                   ########################################### [ 17%]
  58:ncurses4               ########################################### [ 18%]
  59:nfs-utils              ########################################### [ 18%]
  60:openldap               ########################################### [ 18%]
  61:openssh                ########################################### [ 18%]
  62:pam                    ########################################### [ 19%]
  63:perl                   ########################################### [ 19%]
  64:php                    ########################################### [ 19%]
  65:pine                   ########################################### [ 20%]
  66:printconf              ########################################### [ 20%]
  67:python-popt            ########################################### [ 20%]
  68:python-xmlrpc          ########################################### [ 21%]
  69:raidtools              ########################################### [ 21%]
  70:redhat-config-network  ########################################### [ 21%]
  71:rhn_register           ########################################### [ 22%]
  72:rpm                    ########################################### [ 22%]
  73:rpm2html               ########################################### [ 22%]
  74:rpmfind                ########################################### [ 22%]
  75:rsync                  ########################################### [ 23%]
  76:sane-backends          ########################################### [ 23%]
  77:semi                   ########################################### [ 23%]
  78:squid                  ########################################### [ 24%]
  79:stunnel                ########################################### [ 24%]
  80:sudo                   ########################################### [ 24%]
  81:tcpdump                ########################################### [ 25%]
  82:tetex                  ########################################### [ 25%]
  83:tmpwatch               ########################################### [ 25%]
  84:ttfonts-ja             ########################################### [ 26%]
  85:tux                    ########################################### [ 26%]
  86:ucd-snmp               ########################################### [ 26%]
  87:up2date                ########################################### [ 27%]
  88:usermode               ########################################### [ 27%]
  89:util-linux             ########################################### [ 27%]
  90:uucp                   ########################################### [ 27%]
  91:vim                    ########################################### [ 28%]
  92:vnc                    ########################################### [ 28%]
  93:webalizer              ########################################### [ 28%]
  94:wu-ftpd                ########################################### [ 29%]
  95:xchat                  ########################################### [ 29%]
  96:xemacs                 ########################################### [ 29%]
  97:xsane                  ########################################### [ 30%]
  98:zlib                   ########################################### [ 30%]


AND RUNNING THE SAME EXACT COMMAND ON A MACHINE THAT IS BEING UPDATED MANUALLY
WITH EXACTLY THE SAME SINGLE RPM COMMAND ("rpm -Uvh *.rpm") PRODUCES THIS RESULT:
Preparing...                ########################################### [100%]
package Omni-0.5.0-4 is already installed
package Omni-foomatic-0.5.0-4 is already installed
package apache-1.3.22-2 is already installed
package apache-devel-1.3.22-2 is already installed
package apache-manual-1.3.22-2 is already installed
package arpwatch-2.1a11-10.7x is already installed
package at-3.1.8-23 is already installed
package balsa-1.2.3-1 is already installed
package binutils-2.11.90.0.8-12 is already installed
package cvs-1.11.1p1-7 is already installed
package kernel-2.4.9-31 is already installed
package kernel-debug-2.4.9-31 is already installed
package kernel-doc-2.4.9-31 is already installed
package kernel-headers-2.4.9-31 is already installed
package kernel-source-2.4.9-31 is already installed
package modutils-2.4.13-0.7.1 is already installed
package perl-5.6.1-26.72.3 is already installed
package perl-CGI-2.752-26.72.3 is already installed
package perl-CPAN-1.59_54-26.72.3 is already installed
package perl-DB_File-1.75-26.72.3 is already installed
package perl-NDBM_File-1.75-26.72.3 is already installed
package tux-2.2.0-1 is already installed
package up2date-2.7.61-7.x.2 is already installed
package up2date-gnome-2.7.61-7.x.2 is already installed
   1:Mesa                   ########################################### [  0%]
   2:Omni                   ########################################### [  0%]
   3:XFree86                ########################################### [  0%]
   4:Xconfigurator          ########################################### [  1%]
   5:apache                 ########################################### [  1%]
   6:at                     ########################################### [  1%]
   7:balsa                  ########################################### [  2%]
   8:binutils               ########################################### [  2%]
   9:cvs                    ########################################### [  2%]
  10:cyrus-sasl             ########################################### [  3%]
  11:diskcheck              ########################################### [  3%]
  12:dump                   ########################################### [  3%]
  13:e2fsprogs              ########################################### [  4%]
  14:eel                    ########################################### [  4%]
  15:enscript               ########################################### [  4%]
  16:ethereal               ########################################### [  4%]
  17:foomatic    ########################################### [  5%]
  18:gcc3                   ########################################### [  5%]
  19:gdb                    ########################################### [  5%]
  20:ghostscript            ########################################### [  6%]
  21:glibc                  ########################################### [  6%]
  22:gnorpm                 ########################################### [  6%]
  23:groff                  ########################################### [  7%]
  24:htdig                  ########################################### [  7%]
  25:imlib                  ########################################### [  7%]
  26:initscripts            ########################################### [  8%]
  27:iptables               ########################################### [  8%]
  28:jadetex                ########################################### [  8%]
  29:kde-i18n               ########################################### [  9%]
  30:kdeaddons              ########################################### [  9%]
  31:kdeadmin               ########################################### [  9%]
  32:kdeartwork             ########################################### [  9%]
  33:kdebase                ########################################### [ 10%]
  34:kdebindings            ########################################### [ 10%]
  35:kdegames               ########################################### [ 10%]
  36:kdegraphics            ########################################### [ 11%]
  37:kdelibs                ########################################### [ 11%]
  38:kdemultimedia          ########################################### [ 11%]
  39:kdenetwork             ########################################### [ 12%]
  40:kdepim                 ########################################### [ 12%]
  41:kdesdk                 ########################################### [ 12%]
  42:kdetoys                ########################################### [ 13%]
  43:kdeutils               ########################################### [ 13%]
  44:kdevelop               ########################################### [ 13%]
  45:kdoc                   ########################################### [ 13%]
  46:kernel                 ########################################### [ 14%]
  47:koffice                ########################################### [ 14%]
  48:libgcj                 ########################################### [ 14%]
  49:libxml2                ########################################### [ 15%]
  50:libxslt                ########################################### [ 15%]
  51:logwatch               ########################################### [ 15%]
  52:mailman                ########################################### [ 16%]
  53:mod_auth_pgsql         ########################################### [ 16%]
  54:mod_perl               ########################################### [ 16%]
  55:mod_ssl                ########################################### [ 17%]
  56:modutils               ########################################### [ 17%]
  57:mutt                   ########################################### [ 17%]
  58:ncurses4               ########################################### [ 18%]
  59:nfs-utils              ########################################### [ 18%]
  60:openldap               ########################################### [ 18%]
  61:openssh                ########################################### [ 18%]
  62:pam                    ########################################### [ 19%]
  63:perl                   ########################################### [ 19%]
  64:php                    ########################################### [ 19%]
  65:pine                   ########################################### [ 20%]
  66:printconf              ########################################### [ 20%]
  67:python-popt            ########################################### [ 20%]
  68:python-xmlrpc          ########################################### [ 21%]
  69:raidtools              ########################################### [ 21%]
  70:redhat-config-network  ########################################### [ 21%]
  71:rhn_register           ########################################### [ 22%]
  72:rpm                    ########################################### [ 22%]
  73:rpm2html               ########################################### [ 22%]
  74:rpmfind                ########################################### [ 22%]
  75:rsync                  ########################################### [ 23%]
  76:sane-backends          ########################################### [ 23%]
  77:semi                   ########################################### [ 23%]
  78:squid                  ########################################### [ 24%]
  79:stunnel                ########################################### [ 24%]
  80:sudo                   ########################################### [ 24%]
  81:tcpdump                ########################################### [ 25%]
  82:tetex                  ########################################### [ 25%]
  83:tmpwatch               ########################################### [ 25%]
  84:ttfonts-ja             ########################################### [ 26%]
  85:tux                    ########################################### [ 26%]
  86:ucd-snmp               ########################################### [ 26%]
  87:up2date                ########################################### [ 27%]
  88:usermode               ########################################### [ 27%]
  89:util-linux             ########################################### [ 27%]
  90:uucp                   ########################################### [ 27%]
  91:vim                    ########################################### [ 28%]
  92:vnc                    ########################################### [ 28%]
  93:webalizer              ########################################### [ 28%]
  94:wu-ftpd                ########################################### [ 29%]
  95:xchat                  ########################################### [ 29%]
  96:xemacs                 ########################################### [ 29%]
  97:xsane                  ########################################### [ 30%]
  98:zlib                   ########################################### [ 30%]
[root@fortitude rhn]#

The problem seems to be that the exact same number of packages are being updated, but that
up2date has somehow managed to install a significant number of additional packages
that rpm -Uvh *.rpm doesn't seem to detect or install.

Where have I gone wrong (Or should this be sent to the RPM folks?
Comment 3 Aaron Freed 2002-04-25 09:34:35 EDT
When I copied the output of rpm -Uvh *.rpm on alliance (The machine on which up2date was run)
and fortitude (The machine which I am trying to update manually with rpm -Uvh *.rpm) into
two seperate files and then ran this command against them:

 diff allianceRPM.txt fortitudeRPM.txt >uninstalledRPM.txt

the following list of differences is generated, showing the packages that did
NOT get installed on Fortitude by RPM -Uvh *.rpm but DID get installed using
the up2date utility:

2,5d1
< Preparing...                ########################################### [100%]
< package Mesa-3.4.2-10 is already installed
< package Mesa-demos-3.4.2-10 is already installed
< package Mesa-devel-3.4.2-10 is already installed
8,23d3
< package XFree86-100dpi-fonts-4.1.0-15 is already installed
< package XFree86-4.1.0-15 is already installed
< package XFree86-75dpi-fonts-4.1.0-15 is already installed
< package XFree86-ISO8859-15-100dpi-fonts-4.1.0-15 is already installed
< package XFree86-ISO8859-15-75dpi-fonts-4.1.0-15 is already installed
< package XFree86-Xnest-4.1.0-15 is already installed
< package XFree86-Xvfb-4.1.0-15 is already installed
< package XFree86-devel-4.1.0-15 is already installed
< package XFree86-doc-4.1.0-15 is already installed
< package XFree86-libs-4.1.0-15 is already installed
< package XFree86-tools-4.1.0-15 is already installed
< package XFree86-twm-4.1.0-15 is already installed
< package XFree86-xdm-4.1.0-15is already installed
< package XFree86-xf86cfg-4.1.0-15 is already installed
< package XFree86-xfs-4.1.0-15 is already installed
< package Xconfigurator-4.9.39-2 is already installed
28d7
< package arts-2.2.2-2 is already installed
33,111c12,13
< package cyrus-sasl-1.5.24-23 is already installed
< package cyrus-sasl-devel-1.5.24-23 is already installed
< package cyrus-sasl-gssapi-1.5.24-23 is already installed
< package cyrus-sasl-md5-1.5.24-23 is already installed
< package cyrus-sasl-plain-1.5.24-23 is already installed
< package diskcheck-1.1-1 is already installed
< package dump-0.4b25-1.72.0 is already installed
< package e2fsprogs-1.26-1.72 is already installed
< package e2fsprogs-devel-1.26-1.72 is already installed
< package eel-1.0.2-2 is already installed
< package eel-devel-1.0.2-2 is already installed
< package enscript-1.6.1-16.2 is already installed
< package ethereal-0.8.18-10.7.2.1 is already installed
< package ethereal-gnome-0.8.18-10.7.2.1 is already installed
< package foomatic-1.1-0.20011218.3 is already installed
< package gcc3-3.0.4-1 is already installed
< package gcc3-c++-3.0.4-1 is already installed
< package gcc3-g77-3.0.4-1 is already installed
< package gcc3-java-3.0.4-1 is already installed
< package gcc3-objc-3.0.4-1 is already installed
< package gdb-5.1-1 is already installed
< package ghostscript-6.51-16 is already installed
< package glibc-2.2.4-24 is already installed
< package glibc-common-2.2.4-24 is already installed
< package glibc-devel-2.2.4-24 isalready installed
< package glibc-profile-2.2.4-24 is already installed
< package gnorpm-0.96-12.7x is already installed
< package groff-1.17.2-7.0.2 is already installed
< package groff-gxditview-1.17.2-7.0.2 is already installed
< package groff-perl-1.17.2-7.0.2 is already installed
< package htdig-3.2.0-1.b4.0.72 is already installed
< package htdig-web-3.2.0-1.b4.0.72 is already installed
< package imlib-1.9.13-2.7.x is already installed
< package imlib-cfgeditor-1.9.13-2.7.x is already installed
< package imlib-devel-1.9.13-2.7.x is already installed
< package initscripts-6.43-1 is already installed
< package iptables-1.2.4-2 is already installed
< package iptables-ipv6-1.2.4-2 is already installed
< package jadetex-3.11-4 is already installed
< package kde-i18n-Bulgarian-2.2.2-2 is already installed
< package kde-i18n-Hebrew-2.2.2-2 is already installed
< package kde-i18n-Lithuanian-2.2.2-2 is already installed
< package kde-i18n-Polish-2.2.2-2 is already installed
< package kdeaddons-kate-2.2.2-1 is already installed
< package kdeaddons-kicker-2.2.2-1 is already installed
< package kdeaddons-knewsticker-2.2.2-1 is already installed
< package kdeaddons-konqueror-2.2.2-1 is already installed
< package kdeaddons-noatun-2.2.2-1 is already installed
< package kdeadmin-2.2.2-3 is already installed
< package kdeartwork-2.2.2-1 is already installed
< package kdeartwork-locolor-2.2.2-1 is already installed
< package kdebase-2.2.2-1 is already installed
< package kdebase-devel-2.2.2-1 is already installed
< package kdebindings-2.2.2-1 is already installed
< package kdebindings-devel-2.2.2-1 is already installed
< package kdebindings-kmozilla-2.2.2-1 is already installed
< package kdebindings-perl-2.2.2-1 is already installed
< package kdebindings-python-2.2.2-1 is already installed
< package kdegames-2.2.2-1 is already installed
< package kdegraphics-2.2.2-1 is already installed
< package kdegraphics-devel-2.2.2-1 is already installed
< package kdelibs-2.2.2-2 is already installed
< package kdelibs-devel-2.2.2-2 is already installed
< package kdelibs-sound-2.2.2-2 is already installed
< package kdelibs-sound-devel-2.2.2-2 is already installed
< package kdemultimedia-2.2.2-2 is already installed
< package kdemultimedia-devel-2.2.2-2 is already installed
< package kdenetwork-2.2.2-1 is already installed
< package kdenetwork-ppp-2.2.2-1 is already installed
< package kdepim-2.2.2-3 is already installed
< package kdepim-cellphone-2.2.2-3 is already installed
< package kdepim-devel-2.2.2-3 is already installed
< package kdepim-pilot-2.2.2-3 is already installed
< package kdesdk-2.2.2-1 is already installed
< package kdesdk-devel-2.2.2-1 is already installed
< package kdetoys-2.2.2-1 is already installed
< package kdeutils-2.2.2-1 is already installed
< package kdevelop-2.0.2-2 is already installed
< package kdoc-2.2.2-1 is already installed
---
> package kernel-2.4.9-31 is already installed
> package kernel-debug-2.4.9-31 is already installed
115,133d16
< package koffice-1.1.1-2 is already installed
< package koffice-devel-1.1.1-2 is already installed
< package libgcc-3.0.4-1 is already installed
< package libgcj-2.96-28 is already installed
< package libgcj-devel-2.96-28 is already installed
< package libgcj3-3.0.4-1 is already installed
< package libgcj3-devel-3.0.4-1 is already installed
< package libpcap-0.6.2-10.7x is already installed
< package libstdc++3-3.0.4-1 is already installed
< package libstdc++3-devel-3.0.4-1 is already installed
< package libxml2-2.4.10-0.7x.2 is already installed
< package libxml2-devel-2.4.10-0.7x.2 is already installed
< package libxslt-1.0.7-2 is already installed
< package libxslt-devel-1.0.7-2 is already installed
< package logwatch-2.6-1 is already installed
< package mailman-2.0.8-1 is already installed
< package mod_auth_pgsql-0.9.9-2 is already installed
< package mod_perl-1.26-2 is already installed
< package mod_ssl-2.8.5-4 is already installed
135,149d17
< package mutt-1.2.5.1-1 is already installed
< package ncurses4-5.0-5 is already installed
< package nfs-utils-0.3.1-13.7.2.1 is already installed
< package nscd-2.2.4-24 is already installed
< package openldap-2.0.21-1 is already installed
< package openldap-clients-2.0.21-1 is already installed
< package openldap-devel-2.0.21-1 is already installed
< package openldap-servers-2.0.21-1 is already installed
< package openssh-3.1p1-2 is already installed
< package openssh-askpass-3.1p1-2 is already installed
< package openssh-askpass-gnome-3.1p1-2 is already installed
< package openssh-clients-3.1p1-2 is already installed
< package openssh-server-3.1p1-2 is already installed
< package pam-0.75-19 is already installed
< package pam-devel-0.75-19 is already installed
155,198d22
< package php-4.0.6-15 is already installed
< package php-devel-4.0.6-15 is already installed
< package php-imap-4.0.6-15 is already installed
< package php-ldap-4.0.6-15 is already installed
< package php-manual-4.0.6-15 is already installed
< package php-mysql-4.0.6-15 is already installed
< package php-odbc-4.0.6-15 is already installed
< package php-pgsql-4.0.6-15 is already installed
< package pine-4.44-1.72.0 is already installed
< package popt-1.6.4-7x is already installed
< package printconf-0.3.61-3 is already installed
< package printconf-gui-0.3.61-3 is already installed
< package python-popt-0.8.8-7.x.2 is already installed
< package python-xmlrpc-1.5.1-7.x.3 is already installed
< package raidtools-0.90-24 is already installed
< package redhat-config-network-0.9.10-2 is already installed
< package rhn_register-2.7.9-7.x.2 is already installed
< package rhn_register-gnome-2.7.9-7.x.2 is already installed
< package rmt-0.4b25-1.72.0 is already installed
< package rpm-4.0.4-7x is already installed
< package rpm-build-4.0.4-7x is already installed
< package rpm-devel-4.0.4-7x is already installed
< package rpm-perl-4.0.4-7x is already installed
< package rpm-python-4.0.4-7x is already installed
< package rpm2html-1.7-3.7x is already installed
< package rpmfind-1.7-4.7x is already installed
< package rsync-2.4.6-13 is already installed
< package sane-backends-1.0.5-4.1 is already installed
< package sane-backends-devel-1.0.5-4.1 is already installed
< package semi-xemacs-1.14.3-8 is already installed
< package squid-2.4.STABLE3-1.7.2 is already installed
< package stunnel-3.22-1 is already installed
< package sudo-1.6.4-0.7x.2 is already installed
< package tcpdump-3.6.2-10.7x is already installed
< package tetex-1.0.7-38.2 is already installed
< package tetex-afm-1.0.7-38.2 is already installed
< package tetex-doc-1.0.7-38.2 is already installed
< package tetex-dvilj-1.0.7-38.2 is already installed
< package tetex-dvips-1.0.7-38.2 is already installed
< package tetex-fonts-1.0.7-38.2 is already installed
< package tetex-latex-1.0.7-38.2 is already installed
< package tetex-xdvi-1.0.7-38.2 is already installed
< package tmpwatch-2.8.1-1 is already installed
< package ttfonts-ja-1.0-7 is already installed
200,202d23
< package ucd-snmp-4.2.3-1.7.2.3 is already installed
< package ucd-snmp-devel-4.2.3-1.7.2.3 is already installed
< package ucd-snmp-utils-4.2.3-1.7.2.3 is already installed
205,224d25
< package usermode-1.46-1 is already installed
< package util-linux-2.11f-17 is already installed
< package uucp-1.06.1-33.7.2 is already installed
< package vim-X11-6.0-7.13 is already installed
< package vim-common-6.0-7.13 is already installed
< package vim-enhanced-6.0-7.13 is already installed
< package vim-minimal-6.0-7.13 is already installed
< package vnc-3.3.3r2-18.4 is already installed
< package vnc-doc-3.3.3r2-18.4 is already installed
< package vnc-server-3.3.3r2-18.4 is already installed
< package webalizer-2.01_09-0.72 is already installed
< package wu-ftpd-2.6.1-20 is already installed
< package xchat-1.8.7-1.72.0 is already installed
< package xemacs-21.1.14-23.7.2 is already installed
< package xemacs-el-21.1.14-23.7.2 is already installed
< package xemacs-info-21.1.14-23.7.2 is already installed
< package xsane-0.82-3.1 is already installed
< package xsane-gimp-0.82-3.1 is already installed
< package zlib-1.1.3-25.7 is already installed
< package zlib-devel-1.1.3-25.7 is already installed
241c42
<   17:foomatic               ########################################### [  5%]
---
>   17:foomatic    	    ########################################### [  5%]
322,323c123
<   98:zlib                   ########################################### [ 30%]
< 
---
>   98:zlib                   ########################################### [ 30%]
\ No newline at end of file


Again:  perhaps it is up2date that is WORKING properly and RPM that is broken.

IN any event, I really need to have a solution that works (and management won't spring 
for up2date subscriptions for all our machines.  These servers are on an 
isolated network anyway and don't normally have internet access.)

Thank you, in advance (and sorry about the length of this entry.)
Comment 4 Adrian Likins 2002-04-25 13:23:49 EDT
There are several packages that have been added to the distro
as errata (foomatic, Omni, a few others here and there...)


up2date will attempt to solve depenecies until a valid package
transaction set is created. In some cases, this will include
installing new packages that were not previously installed if
a package being updated includes a new requirement (say, foomatic/omni...)

The only thing odd I see in the diff is zlib. Did you miss upgrading zlib
by hand? I would assume it was already installed (it's in base...) and tons
of stuff require it. So seeing it pop up would imply it didnt get upgraded
proplery on one of the machines.

But I'm still not sure I see what is wrong. rpm does not include a depenecy
solver itself, so will not find the new packages or automatically resolve
deps. up2date is designed specifically to do this.
Comment 5 Aaron Freed 2002-04-26 07:21:29 EDT
I think you have probably hit the nail on the head.

(And, yes, zlib had to be manually updated.)

I think RedHat needs to release a new version of rpm OR up2date that includes the dependency solver.  I don't know if rpmfind includes one or not, 
but, for those of us with bosses who won't purchase the up2date service on the internet for each of 30 (or 3000) machines running Linux, there needs 
to be a solution.

In short, given your observation:  rpm lacks a dependency solver, those of us without the up2date subscription service are almost completely unable 
to update our systems because of the numerous dependency errors and failures.  
I was only able to make it work by picking through the entire list of RPMs and updating them singly or in small groups using rpm -Uvh <rpmname>.  
Each time I hit a dependency failure, I skipped that item and went on installing others, in hopes of resolving the dependency issue by the time I 
got back to the item with the failed dependency.  In most cases, this worked, but it took a good three hours of my time

And, rather surprisingly, one item was not able to be installed, because of what appeared to be a circular dependency--or an unresolvable one.  That 
item was the "rpm" program, itself.  To install that, I had to force it with rpm -Uvh rpm* --nodeps.  That does seem to have worked, but this is 
really way too time-consuming and kludgy.

If the idea is to make Linux accessable to the masses (and those of us not patient or knowledgeable enough to spend hours picking through dependency 
failures and RPMs that were not downloaded but are required--I got around THAT problem because I happen to have ONE free up2date subscription that I 
obtained two years ago when the up2date service was free), it is IMPERATIVE THAT A DEPENDENCY RESOLVER BE INCLUDED IN RPM OR THAT A "FREE, MANUAL 
VERSION" OF UP2DATE BE INCLUDED WITH REDHAT LINUX.

PLEASE, GUYS!  DON'T LEAVE THOSE OF US WITH CHEAP BOSSES OUT IN THE COLD!

A.
Comment 6 Adrian Likins 2002-05-08 13:54:00 EDT
I'm going to close this bug, since the up2date client itself appears
to be working correctly. If your interested in it, you can reopen this as
an rpm RFE (for a dep solver in rpm).

But as best I can tell, up2date is working correctly (or at
least, the main issue raised in this bug report is a rpm issue,
not an up2date issue.) If there are other up2date specific bugs, please
open another bug report on up2date with the details.

If you have questions or comments about the RHN pricing model, the best
thing to do is to email rhn-feedback@redhat.com. 

For the time being, every user gets one free system that they can use
via RHN/up2date. If they need more than that, they need to purchase 
additional entitlements for RHN.
Comment 7 Aaron Freed 2002-07-29 09:28:39 EDT
 A decent work-around for this problem so far is to simply run up2date in the 
mode that downloads all necessary files to update your system, but does not 
actually install the updates.  This will get everything, including those RPMs 
necessary to resolve dependency issues.  Then, rpm -Fvh *.rpm or rpm -Uvh 
*.rpm may be run against the downloaded package set at a later time without 
too much trouble (in 7.3.)

Note You need to log in before you can comment on or make changes to this bug.